<!DOCTYPE html>

<html>

<head>

<meta charset="utf-8" />
<meta name="generator" content="pandoc" />
<meta http-equiv="X-UA-Compatible" content="IE=EDGE" />

<meta name="viewport" content="width=device-width, initial-scale=1" />

<meta name="author" content="Giovanny Covarrubias-Pazaran" />

<meta name="date" content="2020-07-16" />

<title>Genetic gain calculation (era trial method)</title>



<style type="text/css">code{white-space: pre;}</style>
<style type="text/css" data-origin="pandoc">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */

</style>
<script>
// apply pandoc div.sourceCode style to pre.sourceCode instead
(function() {
  var sheets = document.styleSheets;
  for (var i = 0; i < sheets.length; i++) {
    if (sheets[i].ownerNode.dataset["origin"] !== "pandoc") continue;
    try { var rules = sheets[i].cssRules; } catch (e) { continue; }
    for (var j = 0; j < rules.length; j++) {
      var rule = rules[j];
      // check if there is a div.sourceCode rule
      if (rule.type !== rule.STYLE_RULE || rule.selectorText !== "div.sourceCode") continue;
      var style = rule.style.cssText;
      // check if color or background-color is set
      if (rule.style.color === '' && rule.style.backgroundColor === '') continue;
      // replace div.sourceCode by a pre.sourceCode rule
      sheets[i].deleteRule(j);
      sheets[i].insertRule('pre.sourceCode{' + style + '}', j);
    }
  }
})();
</script>



<style type="text/css">body {
background-color: #fff;
margin: 1em auto;
max-width: 700px;
overflow: visible;
padding-left: 2em;
padding-right: 2em;
font-family: "Open Sans", "Helvetica Neue", Helvetica, Arial, sans-serif;
font-size: 14px;
line-height: 1.35;
}
#TOC {
clear: both;
margin: 0 0 10px 10px;
padding: 4px;
width: 400px;
border: 1px solid #CCCCCC;
border-radius: 5px;
background-color: #f6f6f6;
font-size: 13px;
line-height: 1.3;
}
#TOC .toctitle {
font-weight: bold;
font-size: 15px;
margin-left: 5px;
}
#TOC ul {
padding-left: 40px;
margin-left: -1.5em;
margin-top: 5px;
margin-bottom: 5px;
}
#TOC ul ul {
margin-left: -2em;
}
#TOC li {
line-height: 16px;
}
table {
margin: 1em auto;
border-width: 1px;
border-color: #DDDDDD;
border-style: outset;
border-collapse: collapse;
}
table th {
border-width: 2px;
padding: 5px;
border-style: inset;
}
table td {
border-width: 1px;
border-style: inset;
line-height: 18px;
padding: 5px 5px;
}
table, table th, table td {
border-left-style: none;
border-right-style: none;
}
table thead, table tr.even {
background-color: #f7f7f7;
}
p {
margin: 0.5em 0;
}
blockquote {
background-color: #f6f6f6;
padding: 0.25em 0.75em;
}
hr {
border-style: solid;
border: none;
border-top: 1px solid #777;
margin: 28px 0;
}
dl {
margin-left: 0;
}
dl dd {
margin-bottom: 13px;
margin-left: 13px;
}
dl dt {
font-weight: bold;
}
ul {
margin-top: 0;
}
ul li {
list-style: circle outside;
}
ul ul {
margin-bottom: 0;
}
pre, code {
background-color: #f7f7f7;
border-radius: 3px;
color: #333;
white-space: pre-wrap; 
}
pre {
border-radius: 3px;
margin: 5px 0px 10px 0px;
padding: 10px;
}
pre:not([class]) {
background-color: #f7f7f7;
}
code {
font-family: Consolas, Monaco, 'Courier New', monospace;
font-size: 85%;
}
p > code, li > code {
padding: 2px 0px;
}
div.figure {
text-align: center;
}
img {
background-color: #FFFFFF;
padding: 2px;
border: 1px solid #DDDDDD;
border-radius: 3px;
border: 1px solid #CCCCCC;
margin: 0 5px;
}
h1 {
margin-top: 0;
font-size: 35px;
line-height: 40px;
}
h2 {
border-bottom: 4px solid #f7f7f7;
padding-top: 10px;
padding-bottom: 2px;
font-size: 145%;
}
h3 {
border-bottom: 2px solid #f7f7f7;
padding-top: 10px;
font-size: 120%;
}
h4 {
border-bottom: 1px solid #f7f7f7;
margin-left: 8px;
font-size: 105%;
}
h5, h6 {
border-bottom: 1px solid #ccc;
font-size: 105%;
}
a {
color: #0033dd;
text-decoration: none;
}
a:hover {
color: #6666ff; }
a:visited {
color: #800080; }
a:visited:hover {
color: #BB00BB; }
a[href^="http:"] {
text-decoration: underline; }
a[href^="https:"] {
text-decoration: underline; }

code > span.kw { color: #555; font-weight: bold; } 
code > span.dt { color: #902000; } 
code > span.dv { color: #40a070; } 
code > span.bn { color: #d14; } 
code > span.fl { color: #d14; } 
code > span.ch { color: #d14; } 
code > span.st { color: #d14; } 
code > span.co { color: #888888; font-style: italic; } 
code > span.ot { color: #007020; } 
code > span.al { color: #ff0000; font-weight: bold; } 
code > span.fu { color: #900; font-weight: bold; } 
code > span.er { color: #a61717; background-color: #e3d2d2; } 
</style>




</head>

<body>




<h1 class="title toc-ignore">Genetic gain calculation (era trial method)</h1>
<h4 class="author">Giovanny Covarrubias-Pazaran</h4>
<h4 class="date">2020-07-16</h4>



<p>The methods explained in the Breeding program assessment manual of EiB are:</p>
<ul>
<li><p>Expected/predicted (1)</p></li>
<li><p>Realized (2)</p></li>
<li><ul>
<li>Historical trials (2.1)</li>
</ul></li>
<li><ul>
<li><ul>
<li>Good connectivity scenario (2.1.1) (<strong>preferred method</strong>)</li>
</ul></li>
</ul></li>
<li><ul>
<li><ul>
<li>Bad connectivity scenario (2.1.2)</li>
</ul></li>
</ul></li>
<li><ul>
<li>Era trials (2.2)</li>
</ul></li>
</ul>
<p>This vignette demonstrates how to calculate the realized rate of genetic gain using trial data from a formal era trial (2.2) experiment that that followed good experimental design practices to maximize accuracy of the estimates. This represents the initial state of many programs to measure the rate of genetic gain that do not have historical information or distrust of it. The number coming from this type of analysis can be considered a baseline or an accurate estimate of this KPI to be shared with funding and collaborator institutions.</p>
<p>As mentioned in the how to manual the ideal method for an institution to estimate the rate of genetic gain is the use of historical data. But to use such data is required to follow recomendation to achieve the connectivity and TPE coverage. The use of era trial should be confined to create a baseline when historical data doesn’t exist or doesn’t meet the minimum quality requirements.</p>
<div id="introducing-the-example" class="section level2">
<h2>INTRODUCING THE EXAMPLE</h2>
<p>Assume a breeding program that has been runing for 20 years and that recycles every 5 years and that comprises the following testing stages:</p>
<ol style="list-style-type: decimal">
<li>STAGE 1</li>
<li>STAGE 2</li>
<li>STAGE 3</li>
<li>ELITE</li>
</ol>
<p>We have made available in the package 15 independent iterations of a simulated breeding program following the proposed structure using the same founding population in order to calculate and estimate of the true and estimated genetic gain. The data that will be loaded has simulated that we have run Era trials sampling material for all the different stages of the breeding program (STAGE 1, 2, 3 ELITE) from the last 20 years (this is unfeasible but not in simulation). In reality usually only one of the testing stages is picked and material is sampled from a time window (here i.e. 20 years).</p>
<p>To show how the calculation is done with this type of data we first load the packages that will be required to do the analysis and visualizations.</p>
</div>
<div id="germplasm-sample-and-time-window-decisions" class="section level2">
<h2>GERMPLASM SAMPLE AND TIME WINDOW DECISIONS</h2>
<p>In practice the program needs to decide which stage or gemplasm sample should be grown in the era trials and for which window of time. In this example we will then load 1 of the 15 simulated iterations available and assume we are interested in sampling the “ELITE” material that has been derived in the las “20 years”.</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb1-1" title="1"><span class="co">########################</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="co"># define time-window and </span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="co"># germplasm sample: &quot;ELITE&quot;, &quot;STAGE3&quot;, &quot;STAGE2&quot;, &quot;STAGE1&quot;</span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="co">########################</span></a>
<a class="sourceLine" id="cb1-5" title="5">gto=<span class="dv">1</span><span class="op">:</span><span class="dv">20</span> <span class="co"># years sampled</span></a>
<a class="sourceLine" id="cb1-6" title="6">sampleEra=<span class="st">&quot;ELITE&quot;</span></a>
<a class="sourceLine" id="cb1-7" title="7">REP=<span class="dv">1</span> <span class="co"># iteration simulated</span></a>
<a class="sourceLine" id="cb1-8" title="8"><span class="kw">load</span>(<span class="kw">file.path</span>(path1,<span class="st">&quot;simulated-data&quot;</span>,<span class="kw">paste0</span>(<span class="st">&quot;BASE_ERA_&quot;</span>,sampleEra,<span class="st">&quot;_&quot;</span>,REP,<span class="st">&quot;.RData&quot;</span>)))</a>
<a class="sourceLine" id="cb1-9" title="9"><span class="co"># subset to take only the last 20 years</span></a>
<a class="sourceLine" id="cb1-10" title="10">EraData &lt;-<span class="st"> </span><span class="kw">droplevels</span>(EraData[<span class="kw">which</span>(EraData<span class="op">$</span>yearOrigin <span class="op">%in%</span><span class="st"> </span><span class="kw">c</span>(<span class="ot">NA</span>,gto)),])</a>
<a class="sourceLine" id="cb1-11" title="11"><span class="kw">head</span>(EraData)</a></code></pre></div>
<pre><code>##    id mom dad generation idn env envn          g        e         ge      error
## 1 631   0   0         10 631  e1    1  0.1691366 1.407874  0.4741808 -0.6120906
## 2 632   0   0         10 632  e1    1  0.3107829 1.407874  1.3268828 -1.0549189
## 3 633   0   0         10 633  e1    1  0.1520629 1.407874  1.6228843  1.9287226
## 4 634   0   0         10 634  e1    1 -1.4849698 1.407874 -3.0389210 -0.6240126
## 5 635   0   0         10 635  e1    1 -0.7184361 1.407874 -0.9050006 -0.2973354
## 6 636   0   0         10 636  e1    1 -1.6482938 1.407874 -2.8236537  0.4894301
##            p planted year stage   type yearOrigin
## 1  1.2699644       0    1   Era Checks         NA
## 2  1.6798380       0    1   Era Checks         NA
## 3  4.9594811       0    1   Era Checks         NA
## 4 -2.2550594       0    1   Era Checks         NA
## 5  0.2055382       0    1   Era Checks         NA
## 6 -0.9263493       0    1   Era Checks         NA</code></pre>
<p>Notice that in the simulated data we have identifiers for individuals, pedigree, environments tested and a check indicator. In addition, we have true genotype, environment and genotype by environment effects, although in reality this is not avaialable and needs to be estimated. The simulations allow us to see how good is a method or strategy to estimate accurately these effects. In this case will be used to see how accurate the era trials are to estimate the true genetic gain.</p>
</div>
<div id="tpe-coverage-decision" class="section level2">
<h2>TPE COVERAGE DECISION</h2>
<p>In practice the program needs to decide in which environments from the TPE the germplasm sample will be tested to ensure that the TPE is well represented. In this example we have simulated that this trials are grown in all possible environments of the TPE but for the sake of illustrating the reality we will assume that only 20% of the available locations have been used to grow our ELITE material in 2 different years (20*2=40 environments; we sample 4 in each year).</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb3-1" title="1"><span class="co"># 7 out of 20 environments were planted</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="kw">with</span>(EraData, <span class="kw">table</span>(year, env))</a></code></pre></div>
<pre><code>##     env
## year  e1  e2  e3  e4  e5  e6  e7  e8  e9 e10 e11 e12 e13 e14 e15 e16 e17 e18
##    1 130 130 130 130 130 130 130 130 130 130 130 130 130 130 130 130 130 130
##    2 130 130 130 130 130 130 130 130 130 130 130 130 130 130 130 130 130 130
##     env
## year e19 e20
##    1 130 130
##    2 130 130</code></pre>
<p>And to emulate reality we will remove the data for those environments that we emulated that were not planted.</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb5-1" title="1"><span class="co"># we subset to only considered environments</span></a>
<a class="sourceLine" id="cb5-2" title="2">finalData &lt;-<span class="st"> </span><span class="kw">droplevels</span>(EraData[<span class="kw">which</span>(EraData<span class="op">$</span>planted <span class="op">==</span><span class="st"> </span><span class="dv">1</span>),]) <span class="co"># keep only environments sampled</span></a>
<a class="sourceLine" id="cb5-3" title="3"><span class="co"># subset to material of interest (elite lines and checks, remove control population)</span></a>
<a class="sourceLine" id="cb5-4" title="4">finalData &lt;-<span class="st"> </span><span class="kw">droplevels</span>(finalData[<span class="kw">which</span>(finalData<span class="op">$</span>type <span class="op">%in%</span><span class="st"> </span><span class="kw">c</span>(<span class="st">&quot;Forward&quot;</span>, <span class="st">&quot;Checks&quot;</span>)),])</a>
<a class="sourceLine" id="cb5-5" title="5"><span class="kw">with</span>(finalData, <span class="kw">table</span>(year, env))</a></code></pre></div>
<pre><code>##     env
## year  e2  e3  e6  e9 e15 e19 e20
##    1 110 110   0 110 110   0   0
##    2   0   0 110 110   0 110 110</code></pre>
<p>The resulting dataset contains ELITE lines and checks evaluated in 4 environments in 2 years assuming that material was evaluated with 3 reps in each environment where the plot h2 was 0.2 (you can check the simulation parameters in the RUN_ERA.R script available in the simulated_data folder).</p>
</div>
<div id="the-genetic-gain-calculation" class="section level2">
<h2>THE GENETIC GAIN CALCULATION</h2>
<p>Once the data has been collected from the different environments for a given germplasm sample, we can proceed to fit a mixed model. In this example we already have the simulated phenotypes and can proceed to the analysis.</p>
<div id="put-the-data-in-good-shape" class="section level3">
<h3>1) Put the data in good shape</h3>
<p>We first define some additional variables as factor to ensure a good estimation of the year and material type effects.</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb7-1" title="1">finalData<span class="op">$</span>yearf &lt;-<span class="st"> </span><span class="kw">as.factor</span>(finalData<span class="op">$</span>year) <span class="co"># convert to factor</span></a>
<a class="sourceLine" id="cb7-2" title="2">finalData<span class="op">$</span>typef &lt;-<span class="st"> </span><span class="kw">as.factor</span>(finalData<span class="op">$</span>type) <span class="co"># convert to factor</span></a>
<a class="sourceLine" id="cb7-3" title="3">finalData &lt;-<span class="st"> </span>finalData[<span class="kw">with</span>(finalData, <span class="kw">order</span>(<span class="op">-</span>envn)), ] <span class="co"># sort data by environments for modeling</span></a></code></pre></div>
</div>
<div id="the-mixed-model" class="section level3">
<h3>2) The mixed model</h3>
<p>With the data in good shape we can fit a mixed model of the form:</p>
<p><span class="math inline">\(y=X\beta+Zu+\epsilon\)</span></p>
<p>where year and the genotype effect are fitted as fixed effects (<span class="math inline">\(\beta\)</span>) and location and year by genotype interaction as random effects (<span class="math inline">\(u\)</span>). The residuals (<span class="math inline">\(\epsilon\)</span>) are fitted with a diagonal structure to allow for different residuals at each location.</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb8-1" title="1"><span class="co">###################</span></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="co"># estimated genetic gain</span></a>
<a class="sourceLine" id="cb8-3" title="3"><span class="co">###################</span></a>
<a class="sourceLine" id="cb8-4" title="4">mix.var &lt;-<span class="st"> </span><span class="kw">asreml</span>(p<span class="op">~</span><span class="st"> </span>yearf <span class="op">+</span><span class="st"> </span>id,</a>
<a class="sourceLine" id="cb8-5" title="5">                  <span class="dt">random=</span> <span class="op">~</span><span class="st"> </span>env <span class="op">+</span><span class="st"> </span>yearf<span class="op">:</span>id<span class="co"># optional yearf:env + env:id</span></a>
<a class="sourceLine" id="cb8-6" title="6">                  ,</a>
<a class="sourceLine" id="cb8-7" title="7">                  <span class="dt">residual=</span><span class="op">~</span><span class="kw">dsum</span>(<span class="op">~</span>units <span class="op">|</span><span class="st"> </span>env),</a>
<a class="sourceLine" id="cb8-8" title="8">                  <span class="dt">data=</span><span class="kw">droplevels</span>(finalData), </a>
<a class="sourceLine" id="cb8-9" title="9">                  <span class="dt">maxiter=</span><span class="dv">50</span>, <span class="dt">workspace=</span><span class="dv">250000000</span>, <span class="dt">trace=</span><span class="ot">FALSE</span></a>
<a class="sourceLine" id="cb8-10" title="10">)</a>
<a class="sourceLine" id="cb8-11" title="11"><span class="kw">summary</span>(mix.var)<span class="op">$</span>varcomp</a></code></pre></div>
<pre><code>##            component std.error   z.ratio bound %ch
## env       7.17938316 4.1480148 1.7307998     P 0.3
## yearf:id  0.02894625 0.1018022 0.2843381     P 0.0
## env_e20!R 2.71738888 0.4281722 6.3464862     P 0.0
## env_e19!R 3.28500225 0.4999062 6.5712368     P 0.0
## env_e15!R 2.69218565 0.4240615 6.3485739     P 0.0
## env_e9!R  2.72130116 0.3099639 8.7794128     P 0.0
## env_e6!R  1.99202187 0.3331379 5.9795718     P 0.0
## env_e3!R  2.57467956 0.4112236 6.2610202     P 0.0
## env_e2!R  2.84415836 0.4460117 6.3768687     P 0.0</code></pre>
<p>Looking at the variance components it seems that the random effects are different than zero according to the Z.ratio.</p>
</div>
<div id="predict-means-and-merge-the-year-of-origin" class="section level3">
<h3>3) Predict means and merge the year of origin</h3>
<p>The program should be able to know what’s the year of origin (year when the material was recycled) of the materials. We can use the predict function to obtain across-location-year means for the different genotypes. Notice that not only the same genotypes show in all locations and years, on top of that checks connect the data. This is the reason why the era trials represent a highly accurate estimation of genetic gain.</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb10-1" title="1">base &lt;-<span class="st"> </span><span class="kw">unique</span>(finalData[,<span class="kw">c</span>(<span class="st">&quot;id&quot;</span>,<span class="st">&quot;yearOrigin&quot;</span>)]) <span class="co"># extract year of origin for materials to merge later</span></a>
<a class="sourceLine" id="cb10-2" title="2">predictions &lt;-<span class="st"> </span><span class="kw">predict</span>(mix.var, <span class="dt">classify =</span> <span class="st">&quot;id&quot;</span>, <span class="dt">trace=</span><span class="ot">FALSE</span>)<span class="co"># obtain across years and across environment means</span></a>
<a class="sourceLine" id="cb10-3" title="3">predictions2 &lt;-<span class="st"> </span>predictions<span class="op">$</span>pvals <span class="co"># extract adjusted means</span></a>
<a class="sourceLine" id="cb10-4" title="4">predictions3 &lt;-<span class="st"> </span><span class="kw">merge</span>(predictions2, base, <span class="dt">by=</span><span class="st">&quot;id&quot;</span>) <span class="co"># add year of origin to adjusted means</span></a>
<a class="sourceLine" id="cb10-5" title="5">predictions3 &lt;-<span class="st"> </span>predictions3[<span class="kw">which</span>(predictions3<span class="op">$</span>yearOrigin <span class="op">&gt;</span><span class="dv">0</span>),] <span class="co"># remove checks</span></a>
<a class="sourceLine" id="cb10-6" title="6"><span class="kw">head</span>(predictions3)</a></code></pre></div>
<pre><code>##       id predicted.value std.error    status yearOrigin
## 1 221722       11.387003  1.164864 Estimable          1
## 2 222410       11.202006  1.164864 Estimable          1
## 3 222459       10.058550  1.164864 Estimable          1
## 4 222530        9.716613  1.164864 Estimable          1
## 5 222637        9.000930  1.164864 Estimable          1
## 6 231799       11.885476  1.164864 Estimable          2</code></pre>
<p>Notice that prediction are linked not only to specific genotypes but now we also have the year of origin of each material.</p>
</div>
<div id="the-response-to-selection-and-rate-of-gain" class="section level3">
<h3>4) The response to selection and rate of gain</h3>
<p>This results can be used to calculate the response to selection obtained by year:</p>
<div class="sourceCode" id="cb12"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb12-1" title="1">R0 &lt;-<span class="st"> </span><span class="kw">aggregate</span>(predicted.value<span class="op">~</span>yearOrigin,<span class="dt">data=</span>predictions3, <span class="dt">FUN=</span>mean)</a>
<a class="sourceLine" id="cb12-2" title="2"><span class="kw">mean</span>(<span class="kw">diff</span>(R0<span class="op">$</span>predicted.value)) <span class="co"># mean response per year</span></a></code></pre></div>
<pre><code>## [1] 0.2209285</code></pre>
<div class="sourceCode" id="cb14"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb14-1" title="1">R0<span class="op">$</span>predicted.value[<span class="kw">nrow</span>(R0)] <span class="op">-</span><span class="st"> </span>R0<span class="op">$</span>predicted.value[<span class="dv">1</span>]<span class="co"># total response across years</span></a></code></pre></div>
<pre><code>## [1] 4.197642</code></pre>
<p>Is more effective if we fit a linear model and use the slope of the regression as the rate of gain per year:</p>
<div class="sourceCode" id="cb16"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb16-1" title="1">mix.var2 &lt;-<span class="st"> </span><span class="kw">lm</span>(predicted.value<span class="op">~</span>yearOrigin, <span class="dt">data=</span>predictions3) <span class="co"># fit the second model</span></a>
<a class="sourceLine" id="cb16-2" title="2">b2=<span class="kw">summary</span>(mix.var2)<span class="op">$</span>coefficients[<span class="dv">2</span>,<span class="dv">1</span>]; b2 <span class="co"># extract rate of genetic gain</span></a></code></pre></div>
<pre><code>## [1] 0.1586059</code></pre>
<p>As we mentioned at the beggining since we simulated the data we know the real rate of genetic gain:</p>
<div class="sourceCode" id="cb18"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb18-1" title="1"><span class="co"># true genetic gain</span></a>
<a class="sourceLine" id="cb18-2" title="2">realGainData &lt;-<span class="st"> </span><span class="kw">droplevels</span>(EraData[<span class="kw">which</span>(EraData<span class="op">$</span>type <span class="op">%in%</span><span class="st"> </span><span class="kw">c</span>(<span class="st">&quot;Forward&quot;</span>)),]) <span class="co"># filter original data to only forward breeding material (no checks or control population)</span></a>
<a class="sourceLine" id="cb18-3" title="3">realGainData &lt;-<span class="st"> </span><span class="kw">aggregate</span>(g<span class="op">~</span>id<span class="op">+</span>yearOrigin,<span class="dt">data=</span>realGainData, <span class="dt">FUN=</span>mean) <span class="co"># aggregate by year of origin</span></a>
<a class="sourceLine" id="cb18-4" title="4">mix.var.true &lt;-<span class="st"> </span><span class="kw">lm</span>(g<span class="op">~</span>yearOrigin, <span class="dt">data=</span>realGainData) <span class="co"># fit a model for true genetic gain</span></a>
<a class="sourceLine" id="cb18-5" title="5">b2=<span class="kw">summary</span>(mix.var.true)<span class="op">$</span>coefficients[<span class="dv">2</span>,<span class="dv">1</span>]; b2 <span class="co"># extract true rate of genetic gain</span></a></code></pre></div>
<pre><code>## [1] 0.1582083</code></pre>
<p>As can be seen the two rates are very simila which shows that an era trial can be good to estimate the rate of gain. The great disadvantage is the cost of running special trials for getting this value. Following Excellence in Breeding recommendations on connectivity of trials using checks in order to be able to use historical data to calculate the rate of gain is a preferred over the era trials and is our recommendation.</p>
</div>
</div>
<div id="final-remarks" class="section level2">
<h2>Final remarks</h2>
<p>The calculation of this rate of genetic gain is straight forward but should be only as a intermediate method while a check connectivity and replacement strategy is put in place to use the historical data to calculate the rate of genetic gain.</p>
</div>
<div id="literature" class="section level2">
<h2>Literature</h2>
<p>Covarrubias-Pazaran G. 2020. Genetic gain as a high level key performance indicator. <a href="https://excellenceinbreeding.org/toolbox/tools/eib-breeding-scheme-optimization-manuals" class="uri">https://excellenceinbreeding.org/toolbox/tools/eib-breeding-scheme-optimization-manuals</a></p>
<p>Walsh, B. 2004. Population-and quantitative-genetic models of selection limits. Plant breeding reviews 24.1: 177-226.</p>
</div>



<!-- code folding -->


<!-- dynamically load mathjax for compatibility with self-contained -->
<script>
  (function () {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src  = "https://mathjax.rstudio.com/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML";
    document.getElementsByTagName("head")[0].appendChild(script);
  })();
</script>

</body>
</html>
